﻿-- Broker_RecountStats : A Data Broker plugin for the "Recount" AddOn (Cryect, Elsia), all rights recognized
-- Loosely based on FuBar_RecountFu
-- Embed & stuff, create DO etc...
local BRRecStats = CreateFrame("Frame", "Broker_RecountStats")
local menuframe = CreateFrame("Frame", "Broker_RecountStats_Menu", UIParent, "UIDropDownMenuTemplate")
local tooltip = LibStub("LibQTip-1.0")
--local L = LibStub("AceLocale-3.0"):GetLocale("Broker_RecountStats", true)
BRRecStats.obj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("Broker_RecountStats", {type = "data source", label = "Recount Stats", icon = "Interface\\Addons\\Broker_RecountStats\\icon.tga", text = "|cffffffff".."No Data".."|r"})
LibStub("AceTimer-3.0"):Embed(BRRecStats)
LibStub("AceHook-3.0"):Embed(BRRecStats)

BRRecStats:RegisterEvent("ADDON_LOADED")
BRRecStats:RegisterEvent("PLAYER_LOGIN")
BRRecStats:RegisterEvent("PLAYER_ENTERING_WORLD")
BRRecStats:RegisterEvent("PLAYER_REGEN_ENABLED") -- End Combat
BRRecStats:RegisterEvent("PLAYER_REGEN_DISABLED") -- In Combat
BRRecStats:RegisterEvent("PLAYER_UNGHOST")
BRRecStats:RegisterEvent("PLAYER_ALIVE")


BRRecStats:SetScript("OnEvent", function(_, event, ...)
	BRRecStats[event](BRRecStats, ...)
end)

-- local variables go here
local _G = getfenv(0)
local Epsilon = 0.000000000000000001
local headers = {}
local tt = nil
local totaltime = 0
local colortable = _G["RAID_CLASS_COLORS"]
colortable["PET"] = {r = 0.09, g = 0.61, b = 0.55}
colortable["UNKNOWN"] = {r = 0.49803921568627, g = 0.49803921568627, b = 0.49803921568627}
colortable["MOB"] = {r = 0.58, g = 0.24, b = 0.63}
colortable["UNGROUPED"] = {r = 0.63, g = 0.58, b = 0.24}
colortable["HOSTILE"] = {r = 0.7, g = 0.1, b = 0.1}


-- Helper funcs
local function ClassColorise(class, targetstring)
if not targetstring then return "" end
if not class then class = "Unknown" end
	local classUpper = strupper(class)
	local pclass = string.gsub(classUpper, " ", "")
	-- if class is of custom type not already set, set a dark green color
	if not colortable[pclass] then colortable[pclass] = {r = 0.35686274509804, g = 0.56470588235294, b = 0.031372549019608} end
	local r = string.format("%x", math.floor(colortable[pclass].r * 255))
	if strlen(r) == 1 then
		r = "0"..r
	end
	local g = string.format("%x", math.floor(colortable[pclass].g * 255))
	if strlen(g) == 1 then
		g = "0"..g
	end
	local b = string.format("%x", math.floor(colortable[pclass].b * 255))
	if strlen(b) == 1 then
		b = "0"..b
	end
	return "|cff"..r..g..b..targetstring.._G["FONT_COLOR_CODE_CLOSE"]
end

local function CloseRightClickMenu()
	if DropDownList1:IsVisible() then
		DropDownList1:Hide()
	end
end

local function GetFullTimeText(s)
	if not s then return "N/A" end
	if s < 0 then return "N/A" end

	local minutes = floor(s/60)
	s = mod(s, 60)
	local seconds = s
	return format("%2d".."m"..", %2d".."s", minutes, seconds)
end

local function hidett(self, elapsed)
	totaltime = totaltime + elapsed
	if totaltime > 0.2 then
		totaltime = 0
		if tt and not MouseIsOver(tt) then
			tt:SetScript("OnEnter", nil)
			tt:SetScript("OnLeave", nil)	
			tooltip:Release(tt)
			tt = nil
			BRRecStats:SetScript("OnUpdate", nil)
		elseif not tt then
			BRRecStats:SetScript("OnUpdate", nil)
		end
	end
end

-- Dropdown menu init function
local function DropdownInitFunction()
local info
if _G["UIDROPDOWNMENU_MENU_LEVEL"] == 3 then
	if _G["UIDROPDOWNMENU_MENU_VALUE"] == "SessionText" then
		info = {}
		info.text = "Session"
		info.notClickable = 1
		info.isTitle = 1
		UIDropDownMenu_AddButton(info, 3)
		info = {}
		info.text = "Overall"
		info.checked = function() if Broker_RecStatsConfig.dps_type == "Overall" then return true else return false end end
		info.func = function() Broker_RecStatsConfig.dps_type = "Overall" BRRecStats:Update() end
		UIDropDownMenu_AddButton(info, 3)
		info = {}
		info.text = "Last Fight"
		info.checked = function() if Broker_RecStatsConfig.dps_type == "LastFight" then return true else return false end end
		info.func = function() Broker_RecStatsConfig.dps_type = "LastFight" BRRecStats:Update() end
		UIDropDownMenu_AddButton(info, 3)
	end
	if _G["UIDROPDOWNMENU_MENU_VALUE"] == "SessionTooltip" then
		info = {}
		info.text = "Session"
		info.notClickable = 1
		info.isTitle = 1
		UIDropDownMenu_AddButton(info, 3)
		info = {}
		info.text = "Overall"
		info.checked = function() if Broker_RecStatsConfig.mode_type_tip == "OverallData" then return true else return false end end
		info.func = function() Broker_RecStatsConfig.mode_type_tip = "OverallData" end
		UIDropDownMenu_AddButton(info, 3)
		info = {}
		info.text = "Last Fight"
		info.checked = function() if Broker_RecStatsConfig.mode_type_tip == "LastFightData" then return true else return false end end
		info.func = function() Broker_RecStatsConfig.mode_type_tip = "LastFightData" end
		UIDropDownMenu_AddButton(info, 3)
	end
	if _G["UIDROPDOWNMENU_MENU_VALUE"] == "DisplayModeTooltip" then
		info = {}
		info.text = "Display Mode"
		info.notClickable = 1
		info.isTitle = 1
		UIDropDownMenu_AddButton(info, 3)
		info = {}
		info.text = "Damage"
		info.checked = function() if Broker_RecStatsConfig.show_tip == "DPS" then return true else return false end end
		info.func = function() Broker_RecStatsConfig.show_tip = "DPS" end
		UIDropDownMenu_AddButton(info, 3)
		info = {}
		info.text = "Healing"
		info.checked = function() if Broker_RecStatsConfig.show_tip == "Heal" then return true else return false end end
		info.func = function() Broker_RecStatsConfig.show_tip = "Heal" end
		UIDropDownMenu_AddButton(info, 3)
	end
	if _G["UIDROPDOWNMENU_MENU_VALUE"] == "DisplayModeText" then
		info = {}
		info.text = "Display Mode"
		info.notClickable = 1
		info.isTitle = 1
		UIDropDownMenu_AddButton(info, 3)
		info = {}
		info.text = "Damage"
		info.checked = function() if Broker_RecStatsConfig.show_text == "DPS" then return true else return false end end
		info.func = function() Broker_RecStatsConfig.show_text = "DPS" BRRecStats:Update() end
		UIDropDownMenu_AddButton(info, 3)
		info = {}
		info.text = "Healing"
		info.checked = function() if Broker_RecStatsConfig.show_text == "Heal" then return true else return false end end
		info.func = function() Broker_RecStatsConfig.show_text = "Heal" BRRecStats:Update() end
		UIDropDownMenu_AddButton(info, 3)
	end
	if _G["UIDROPDOWNMENU_MENU_VALUE"] == "TextType" then
		info = {}
		info.text = "Self/Raid Type"
		info.notClickable = 1
		info.isTitle = 1
		UIDropDownMenu_AddButton(info, 3)
		info = {}
		info.text = "Raid"
		info.checked = function() if Broker_RecStatsConfig.dps_raid == "RaidDPS" then return true else return false end end
		info.func = function() Broker_RecStatsConfig.dps_raid = "RaidDPS" BRRecStats:Update() end
		UIDropDownMenu_AddButton(info, 3)
		info = {}
		info.text = "Personal"
		info.checked = function() if Broker_RecStatsConfig.dps_raid == "SelfDPS" then return true else return false end end
		info.func = function() Broker_RecStatsConfig.dps_raid = "SelfDPS" BRRecStats:Update() end
		UIDropDownMenu_AddButton(info, 3)
	end
return
end

-- level 2
if _G["UIDROPDOWNMENU_MENU_LEVEL"] == 2 then
	if _G["UIDROPDOWNMENU_MENU_VALUE"] == "Text" then
		info = {}
		info.text = "Text"
		info.notClickable = 1
		info.isTitle = 1
		UIDropDownMenu_AddButton(info, 2)
		info = {}
		info.text = "Show Combat Time"
		info.checked = function() return Broker_RecStatsConfig.show_combat_time end
		info.func = function()
			if Broker_RecStatsConfig.show_combat_time then
				Broker_RecStatsConfig.show_combat_time = false
			else
				Broker_RecStatsConfig.show_combat_time = true
			end
		BRRecStats:Update()
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, 2)
		info = {}
		info.text = "Display Mode"
		info.value = "DisplayModeText"
		info.hasArrow = 1
		UIDropDownMenu_AddButton(info, 2)
		info = {}
		info.text = "Session"
		info.value = "SessionText"
		info.hasArrow = 1
		UIDropDownMenu_AddButton(info, 2)
		info = {}
		info.text = "Self/Raid Type"
		info.value = "TextType"
		info.hasArrow = 1
		UIDropDownMenu_AddButton(info, 2)
		info = {}
		info.text = "Update Frequency".." : ".._G["NORMAL_FONT_COLOR_CODE"]..Broker_RecStatsConfig.update_time
		info.func = function() BRRecStats:UpdateFrequencyPopup() end
		UIDropDownMenu_AddButton(info, 2)
	end
	if _G["UIDROPDOWNMENU_MENU_VALUE"] == "RecountReport" then
		info = {}
		info.text = "Recount Report"
		info.notClickable = 1
		info.isTitle = 1
		UIDropDownMenu_AddButton(info, 2)
		info = {}
		info.text = "Main"
		info.func = function() Recount:ShowReport("Main",Recount.ReportData) end
		UIDropDownMenu_AddButton(info, 2)
		info = {}
		info.text = "Detail"
		info.func = function() Recount:ShowReport("Detail",Recount.ReportDetail) end
		UIDropDownMenu_AddButton(info, 2)
	end
	if _G["UIDROPDOWNMENU_MENU_VALUE"] == "RecountViewMode" then
		info = {}
		info.text = "Recount View Mode"
		info.notClickable = 1
		info.isTitle = 1
		UIDropDownMenu_AddButton(info, 2)
		info = {}
		for k,v in pairs(Recount.MainWindowData) do
		info.text = v[1]
		--desc = string.format(L["Displays the %s mode"],v[1]),
		info.func = function() Recount:SetMainWindowMode(k) end
		UIDropDownMenu_AddButton(info, 2)
		end
	end
	if _G["UIDROPDOWNMENU_MENU_VALUE"] == "Tooltip" then
		info = {}
		info.text = "Tooltip"
		info.notClickable = 1
		info.isTitle = 1
		UIDropDownMenu_AddButton(info, 2)
		info = {}
		info.text = "Display Mode"
		info.value = "DisplayModeTooltip"
		info.hasArrow = 1
		UIDropDownMenu_AddButton(info, 2)
		info = {}
		info.text = "Session"
		info.value = "SessionTooltip"
		info.hasArrow = 1
		UIDropDownMenu_AddButton(info, 2)		
		info = {}
		info.text = "Max Height".." : ".._G["NORMAL_FONT_COLOR_CODE"]..Broker_RecStatsConfig.slidermaxheight
		info.func = function() BRRecStats:UpdateSliderMaxHeight() end
		UIDropDownMenu_AddButton(info, 2)
		info = {}
		info.text = "Hide Hint"
		info.checked = function() return Broker_RecStatsConfig.hidehinttip end
		info.func = function()
			if Broker_RecStatsConfig.hidehinttip then
				Broker_RecStatsConfig.hidehinttip = false
			else
				Broker_RecStatsConfig.hidehinttip = true
			end		
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, 2)
	end
return
end

-- level 1
info = {}
info.text = "Broker Recount Statistics"
info.notClickable = 1
info.isTitle = 1
UIDropDownMenu_AddButton(info)
info = {}
info.text = "Text"
info.value = "Text"
info.hasArrow = 1
UIDropDownMenu_AddButton(info)
info = {}
info.text = "Tooltip"
info.value = "Tooltip"
info.hasArrow = 1
UIDropDownMenu_AddButton(info)
info = {}
info.text = "Recount Report"
info.value = "RecountReport"
info.hasArrow = 1
UIDropDownMenu_AddButton(info)
info = {}
info.text = "Recount View Mode"
info.value = "RecountViewMode"
info.hasArrow = 1
UIDropDownMenu_AddButton(info)
info = {}
info.text = "Recount Configuration"
info.func = function() Recount:ShowConfig() end
UIDropDownMenu_AddButton(info)
end


function BRRecStats:ADDON_LOADED(addon)
	if addon == "Broker_RecountStats" then
		if not Broker_RecStatsConfig then
  		-- initialize default configuration
    		Broker_RecStatsConfig = {
    			dps_type = "LastFight", -- "LastFight" or "Overall"
    			mode_type_tip = "LastFightData", -- "LastFightData" or "OverallData"
    			dps_raid = "SelfDPS", -- "SelfDPS" or "RaidDPS"
					update_time = 1,
					show_text = "DPS", -- "DPS" or "Heal"
					show_tip = "DPS", -- "DPS" or "Heal"
					show_combat_time = false,
					hidehinttip = false,
					slidermaxheight = 400
      	  	}
  	end
  	self:UnregisterEvent("ADDON_LOADED")
  	self.ADDON_LOADED = nil
  end
end

function BRRecStats:ModifyClassColors()
	colortable = _G["CUSTOM_CLASS_COLORS"] or _G["RAID_CLASS_COLORS"]
	if not colortable["PET"] then colortable["PET"] = {r = 0.09, g = 0.61, b = 0.55} end
	if not colortable["UNKNOWN"] then colortable["UNKNOWN"] = {r = 0.49803921568627, g = 0.49803921568627, b = 0.49803921568627} end
	if not colortable["MOB"] then colortable["MOB"] = {r = 0.58, g = 0.24, b = 0.63} end
	if not colortable["UNGROUPED"] then colortable["UNGROUPED"] = {r = 0.63, g = 0.58, b = 0.24} end
	if not colortable["HOSTILE"] then colortable["HOSTILE"] = {r = 0.7, g = 0.1, b = 0.1} end
end

function BRRecStats:getValue(tablename,value)
	local playername = UnitName("player")
	if value == "Damage" then
		local damage,_ = Recount:MergedPetDamageDPS(Recount.db2.combatants[playername],tablename)
		return damage
	else
		local combatData = Recount.db2.combatants[playername] and Recount.db2.combatants[playername].Fights and Recount.db2.combatants[playername].Fights[tablename]
		return combatData and combatData[value] or 0
	end
end

function BRRecStats:getValuePerSecond(tablename,value)
	local playername = UnitName("player")
	if value == "Damage" then
		local _,dps = Recount:MergedPetDamageDPS(Recount.db2.combatants[playername],tablename)
		return math.floor(10 * dps + 0.5)/10
	else
		local combatData = Recount.db2.combatants[playername] and Recount.db2.combatants[playername].Fights and Recount.db2.combatants[playername].Fights[tablename]
		local cvalue = combatData and combatData[value] or 0
		local activetime = combatData and combatData.ActiveTime or 0
		return math.floor(10 * cvalue/(activetime + Epsilon) + 0.5)/10
	end
end

function BRRecStats:getTimeInCombat(tablename)
	return math.floor(10*(self:getValue(tablename,"ActiveTime")+ Epsilon))/10
end

function BRRecStats:getRaidValuePerSecondDPS(tablename)
	local dps, data = 0, nil
	for _,data in pairs(Recount.db2.combatants) do
		if data.Fights and data.Fights[tablename] and (data.type=="Self" or data.type=="Grouped" or data.type=="Pet" or data.type=="Ungrouped") then
			local _,curdps = Recount:MergedPetDamageDPS(data,tablename)
			if data.type ~= "Pet" or (not Recount.db.profile.MergePets and data.Owner and (Recount.db2.combatants[data.Owner].type=="Self" or Recount.db2.combatants[data.Owner].type=="Grouped" or Recount.db2.combatants[data.Owner].type=="Ungrouped")) or (not Recount.db.profile.MergePets and data.Name and data.GUID and self:matchUnitGUID(data.Name, data.GUID)) then
				dps = dps + 10 * curdps
			end
		end
	end
	return math.floor(dps + 0.5)/10
end

function BRRecStats:getRaidValuePerSecondHPS(tablename)
	local dps, data = 0, nil
	for _,data in pairs(Recount.db2.combatants) do
		if data.Fights and data.Fights[tablename] and (data.type=="Self" or data.type=="Grouped" or data.type=="Pet" or data.type=="Ungrouped") then
			local _,curdps = Recount:MergedPetHealingDPS(data,tablename)
			if data.type ~= "Pet" or (not Recount.db.profile.MergePets and data.Owner and (Recount.db2.combatants[data.Owner].type=="Self" or Recount.db2.combatants[data.Owner].type=="Grouped" or Recount.db2.combatants[data.Owner].type=="Ungrouped")) or (not Recount.db.profile.MergePets and data.Name and data.GUID and self:matchUnitGUID(data.Name, data.GUID)) then
				dps = dps + 10 * curdps
			end
		end
	end
	return math.floor(dps + 0.5)/10
end

-- match pets such as elementals with no proper owner, using their unique GUID
function BRRecStats:matchUnitGUID(unitname, guid)
	for _,data in pairs(Recount.db2.combatants) do
		if data.GuardianReverseGUIDs and data.GuardianReverseGUIDs[unitname] and data.GuardianReverseGUIDs[unitname].GUIDs then
			for k,v in pairs(data.GuardianReverseGUIDs[unitname].GUIDs) do
				if v == guid then return true end
			end
		end
	end
	return false
end

function BRRecStats:getDPStable(tablename)
	local data, fullname = nil, ""
	local temptable = {}
	local dmgtable = {}
	for _,data in pairs(Recount.db2.combatants) do
		if data.Fights and data.Fights[tablename] and (data.type=="Self" or data.type=="Grouped" or data.type=="Pet" or data.type=="Ungrouped") then
			local curdmg,curdps = Recount:MergedPetDamageDPS(data,tablename)			
			if data.type ~= "Pet" or (not Recount.db.profile.MergePets and data.Owner and (Recount.db2.combatants[data.Owner].type=="Self" or Recount.db2.combatants[data.Owner].type=="Grouped" or Recount.db2.combatants[data.Owner].type=="Ungrouped")) or (not Recount.db.profile.MergePets and data.Name and data.GUID and self:matchUnitGUID(data.Name, data.GUID)) then
				if curdmg > 0 then
					curdps = math.floor(curdps + 0.5)
					fullname = data.Name or "Unknown"
					if data.type == "Pet" then fullname = data.Name.." <"..data.Owner..">" end
					temptable = {name = fullname, damage = curdmg, dps = curdps, enclass = data.enClass}
					tinsert(dmgtable, temptable)
				end
			end
		end
	end
	table.sort(dmgtable, function(a,b) return a.damage > b.damage end)	
	return dmgtable
end


function BRRecStats:getHealingtable(tablename)
	local data, fullname = nil, ""
	local temptable = {}
	local healtable = {}
	for _,data in pairs(Recount.db2.combatants) do
		if data.Fights and data.Fights[tablename] and (data.type=="Self" or data.type=="Grouped" or data.type=="Pet" or data.type=="Ungrouped") then
			local curheal, curhps = Recount:MergedPetHealingDPS(data,tablename)			
			if data.type ~= "Pet" or (not Recount.db.profile.MergePets and data.Owner and (Recount.db2.combatants[data.Owner].type=="Self" or Recount.db2.combatants[data.Owner].type=="Grouped" or Recount.db2.combatants[data.Owner].type=="Ungrouped")) or (not Recount.db.profile.MergePets and data.Name and data.GUID and self:matchUnitGUID(data.Name, data.GUID)) then
				if curheal > 0 then
					curhps = math.floor(curhps + 0.5)
					fullname = data.Name or "Unknown"
					if data.type == "Pet" then fullname = data.Name.." <"..data.Owner..">" end
					temptable = {name = fullname, healing = curheal, hps = curhps, enclass = data.enClass}
					tinsert(healtable, temptable)
				end
			end
		end
	end
	table.sort(healtable, function(a,b) return a.healing > b.healing end)	
	return healtable
end


function BRRecStats:GetDPSLabel()
	local text = "|cffff8c00".."DPS: ".."|r"
	local CurrentFightDPS = 0
	local LastFightDPS = 0
	
	if Broker_RecStatsConfig.dps_raid == "RaidDPS" then
		text = "|cffff8c00".."RDPS: ".."|r"
	end
	
	if Broker_RecStatsConfig.dps_type == "LastFight" then
		if Recount.InCombat then
			if Broker_RecStatsConfig.dps_raid == "RaidDPS" then
				CurrentFightDPS = self:getRaidValuePerSecondDPS("CurrentFightData")
			else
				CurrentFightDPS = self:getValuePerSecond("CurrentFightData","Damage")
			end
			text = text.."|cff68ccef"..CurrentFightDPS.."|r"
		else
			if Broker_RecStatsConfig.dps_raid == "RaidDPS" then
				LastFightDPS = self:getRaidValuePerSecondDPS("LastFightData")
			else
				CurrentFightDPS = self:getValuePerSecond("LastFightData","Damage")
			end
			if LastFightDPS == 0 then
				if CurrentFightDPS > 0 then
					text = text.."|cffffffff"..CurrentFightDPS.."|r"
				else
					text = text.."|cffffffff".."0".."|r"
				end
			else
				text = text.."|cffffffff"..LastFightDPS.."|r"
			end
		end
	elseif Broker_RecStatsConfig.dps_type == "Overall" then
		if Broker_RecStatsConfig.dps_raid == "RaidDPS" then
			text = text.._G["GREEN_FONT_COLOR_CODE"]..self:getRaidValuePerSecondDPS("OverallData").."|r"
		else
			text = text.._G["GREEN_FONT_COLOR_CODE"]..self:getValuePerSecond("OverallData","Damage").."|r"
		end
	end
	return text
end

function BRRecStats:GetHPSLabel()
	local text = "|cffff8c00".."HPS: ".."|r"
	local CurrentFightHPS = 0
	local LastFightHPS = 0
	
	if Broker_RecStatsConfig.dps_raid == "RaidDPS" then
		text = "|cffff8c00".."RHPS: ".."|r"
	end
	
	if Broker_RecStatsConfig.dps_type == "LastFight" then
		if Recount.InCombat then
			if Broker_RecStatsConfig.dps_raid == "RaidDPS" then
				CurrentFightHPS = self:getRaidValuePerSecondHPS("CurrentFightData")
			else
				CurrentFightHPS = self:getValuePerSecond("CurrentFightData","Healing")
			end
			text = text.."|cff68ccef"..CurrentFightHPS.."|r"
		else
			if Broker_RecStatsConfig.dps_raid == "RaidDPS" then
				LastFightHPS = self:getRaidValuePerSecondHPS("LastFightData")
			else
				CurrentFightHPS = self:getValuePerSecond("LastFightData","Healing")
			end
			if LastFightHPS == 0 then
				if CurrentFightHPS > 0 then
					text = text.."|cffffffff"..CurrentFightHPS.."|r"
				else
					text = text.."|cffffffff".."0".."|r"
				end
			else
				text = text.."|cffffffff"..LastFightHPS.."|r"
			end
		end
	elseif Broker_RecStatsConfig.dps_type == "Overall" then
		if Broker_RecStatsConfig.dps_raid == "RaidDPS" then
			text = text.._G["GREEN_FONT_COLOR_CODE"]..self:getRaidValuePerSecondHPS("OverallData").."|r"
		else
			text = text.._G["GREEN_FONT_COLOR_CODE"]..self:getValuePerSecond("OverallData","Healing").."|r"
		end
	end
	return text
end

function BRRecStats:GetTimeInCombatLabel()
	local text = "|cffff8c00".."  Time:".."|r"
	local timeInCombat
	if Recount.InCombat then
		timeInCombat = GetFullTimeText(self:getTimeInCombat("CurrentFightData"))
		text = text.."|cff68ccef"..timeInCombat.."|r"
	else
		timeInCombat = GetFullTimeText(self:getTimeInCombat("LastFightData"))
		text = text.."|cffffffff"..timeInCombat.."|r"
	end	
	return text
end

function BRRecStats:Update()
	local text = ""
	if Broker_RecStatsConfig.show_text == "DPS" then
		text = text..self:GetDPSLabel()
	elseif Broker_RecStatsConfig.show_text == "Heal" then
		text = text..self:GetHPSLabel()
	end
	
	if Broker_RecStatsConfig.show_combat_time then
		text = text..self:GetTimeInCombatLabel()
	end
	self.obj.text = text
end


function BRRecStats:PLAYER_REGEN_DISABLED()
	self:CancelAllTimers()
	self:ScheduleRepeatingTimer("Update", Broker_RecStatsConfig.update_time)
end

function BRRecStats:PLAYER_REGEN_ENABLED()
	self:CancelAllTimers()
	self:ScheduleTimer("Update", 2)
end

function BRRecStats:PLAYER_UNGHOST()
	self:CancelAllTimers()
	self:Update()
end

function BRRecStats:PLAYER_ALIVE()
	self:CancelAllTimers()
	self:Update()
end

function BRRecStats:RecountHook_UpdateText()
	self:Update()
end

function BRRecStats:PLAYER_LOGIN()
	-- Check if Recount is loaded
	-- in case some malicious user eliminated the ReqDep
	if not IsAddOnLoaded("Recount") then
		DEFAULT_CHAT_FRAME:AddMessage(_G["GREEN_FONT_COLOR_CODE"].."Broker Recount Stats: ".."|r".."Recount addon not loaded. Functionality will be disabled.")
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		self:UnregisterEvent("PLAYER_REGEN_ENABLED")
		self:UnregisterEvent("PLAYER_REGEN_DISABLED")
		self:UnregisterEvent("PLAYER_UNGHOST")
		self:UnregisterEvent("PLAYER_ALIVE")
		self.PLAYER_ENTERING_WORLD = nil
		self.PLAYER_REGEN_ENABLED = nil
		self.PLAYER_REGEN_DISABLED = nil
		self.PLAYER_UNGHOST = nil
		self.PLAYER_ALIVE = nil
	else
		-- initialize dropdown menu
		UIDropDownMenu_Initialize(menuframe, DropdownInitFunction, "MENU")
		-- hook Recount methods, if they exist
		if Recount and Recount.LeaveCombat then BRRecStats:SecureHook(Recount, "LeaveCombat","RecountHook_UpdateText") end
		if Recount and Recount.ResetData then BRRecStats:SecureHook(Recount, "ResetData","RecountHook_UpdateText") end
	end
	-- support for CUSTOM_CLASS_COLORS
	if _G["CUSTOM_CLASS_COLORS"] then
		self:ModifyClassColors()
		_G["CUSTOM_CLASS_COLORS"]:RegisterCallback(function() BRRecStats:ModifyClassColors() end)
	end
	self:UnregisterEvent("PLAYER_LOGIN")
  self.PLAYER_LOGIN = nil
end

function BRRecStats:PLAYER_ENTERING_WORLD()
	self:Update()
end

function BRRecStats.obj.OnClick(self, button)
	if not IsAddOnLoaded("Recount") then return end
	if tt then
		tt:SetScript("OnEnter", nil)
		tt:SetScript("OnLeave", nil)
		tooltip:Release(tt)
		tt = nil
	end
	if button == "LeftButton" and IsAltKeyDown() then
		Recount:ShowReset()
		return
	end
	if button == "LeftButton" and Recount.MainWindow:IsShown() then
		Recount.MainWindow:Hide()
	elseif button == "LeftButton" and not Recount.MainWindow:IsShown() then
		Recount.MainWindow:Show()
		Recount:RefreshMainWindow()
	elseif button == "MiddleButton" then
		Recount:ResetPositions()
		Recount.MainWindow:Show()
		Recount:RefreshMainWindow()
	elseif button == "RightButton" then
		ToggleDropDownMenu(1, nil, menuframe, self, 0, 0, nil, self)
	end
end

function BRRecStats.obj.OnEnter(self)
	if not IsAddOnLoaded("Recount") then return end
	CloseRightClickMenu()
	local colnum = 1	
	local orientation = {}
	headers = {}
	
	-- conditions, set headers and orientations
	-- #
	headers[colnum] = "|cffeda55f#"
	orientation[colnum] = "LEFT"
	
	-- Name
		colnum = colnum + 1
		headers[colnum] = "|cffeda55fName"
		orientation[colnum] = "LEFT"
		
		-- insert empty column
		colnum = colnum + 1
		headers[colnum] = "  "
		orientation[colnum] = "CENTER"
		
		-- insert empty column
		colnum = colnum + 1
		headers[colnum] = "  "
		orientation[colnum] = "CENTER"
		
	-- Damage/Healing
		colnum = colnum + 1
		if Broker_RecStatsConfig.show_tip == "DPS" then
			headers[colnum] = "|cffeda55fDamage"
		else
			headers[colnum] = "|cffeda55fHealing"
		end
		orientation[colnum] = "CENTER"
		
	-- insert empty column
		colnum = colnum + 1
		headers[colnum] = "  "
		orientation[colnum] = "CENTER"
		
	-- DPS/HPS
		colnum = colnum + 1
		if Broker_RecStatsConfig.show_tip == "DPS" then
			headers[colnum] = "|cffeda55fDPS"
		else
			headers[colnum] = "|cffeda55fHPS"
		end
		orientation[colnum] = "RIGHT"
	
	local maxentries = #orientation
	if maxentries ~= 1 then orientation[maxentries] = "RIGHT" end

	-- acquire frame
	tt = tooltip:Acquire("Broker_RecountStats", colnum, unpack(orientation,1,maxentries))
	tt:EnableMouse(true)
	tt:SetScript("OnEnter", function(self) BRRecStats:SetScript("OnUpdate", nil) end)
	tt:SetScript("OnLeave", function(self) BRRecStats:SetScript("OnUpdate", hidett) end)
	tt:SmartAnchorTo(self)
	tt:Clear()
	BRRecStats:Drawtooltip()
	tt:Show()
end

function BRRecStats.obj.OnLeave()
	if not IsAddOnLoaded("Recount") then return end
	if tt and tt:IsVisible() then
		BRRecStats:SetScript("OnUpdate", hidett)
	end
end

function BRRecStats:Drawtooltip()
	local i, j
	local colnum = 1
	StatsTable = {}
	local display = {}
	
	-- Draw tooltip
	local colcount = tt:GetColumnCount()
	local templine = tt:AddLine("")
	local sessionlabel = ""
	if Broker_RecStatsConfig.mode_type_tip == "LastFightData" and Recount.InCombat then sessionlabel = "(".."Current Fight"..")" end
	if Broker_RecStatsConfig.mode_type_tip == "LastFightData" and not Recount.InCombat then sessionlabel = "(".."Last Fight"..")" end
	if Broker_RecStatsConfig.mode_type_tip == "OverallData" then sessionlabel = "(".."Overall"..")" end
	if Broker_RecStatsConfig.show_tip == "DPS" then 
		sessionlabel = sessionlabel.." ".."|cffff8c00".."Damage"
	else
		sessionlabel = sessionlabel.." ".._G["GREEN_FONT_COLOR_CODE"].."Healing"
	end
	tt:SetCell(templine, 1, _G["HIGHLIGHT_FONT_COLOR_CODE"].."Broker Recount Statistics".."|r".._G["NORMAL_FONT_COLOR_CODE"].." "..sessionlabel.."|r", nil, "CENTER", colcount)
	tt:AddLine(" ")
	tt:AddHeader(unpack(headers,1,colcount))
	
	if Broker_RecStatsConfig.show_tip == "DPS" then
		if Recount.InCombat and Broker_RecStatsConfig.mode_type_tip == "LastFightData" then
			StatsTable = self:getDPStable("CurrentFightData")
		else
			StatsTable = self:getDPStable(Broker_RecStatsConfig.mode_type_tip)
		end
	end
	
	if Broker_RecStatsConfig.show_tip == "Heal" then
		if Recount.InCombat and Broker_RecStatsConfig.mode_type_tip == "LastFightData" then
			StatsTable = self:getHealingtable("CurrentFightData")
		else
			StatsTable = self:getHealingtable(Broker_RecStatsConfig.mode_type_tip)
		end
	end
	
	local numofcombatants = #StatsTable
	
	if numofcombatants == 0 then		
		tt:SetCell(3, 1, _G["NORMAL_FONT_COLOR_CODE"].."No data to display".."|r", nil, "CENTER", colcount)
	else		
		for i = 1, numofcombatants do
			colnum = 1
			-- #
			display[colnum] = "|cffffffff"..i..".".."|r"
			
			-- Name
			colnum = colnum + 1
			display[colnum] = ClassColorise(StatsTable[i].enclass, StatsTable[i].name)
			
			-- insert empty column
			colnum = colnum + 1
			display[colnum] = "  "
		
			-- insert empty column
			colnum = colnum + 1
			display[colnum] = "  "
			
			-- Damage/Healing
			colnum = colnum + 1
			if Broker_RecStatsConfig.show_tip == "DPS" then
				display[colnum] = StatsTable[i].damage
			else
				display[colnum] = StatsTable[i].healing
			end
			
			-- insert empty column
			colnum = colnum + 1
			display[colnum] = "  "
			
			-- DPS/HPS
			colnum = colnum + 1
			if Broker_RecStatsConfig.show_tip == "DPS" then
				display[colnum] = StatsTable[i].dps
			else
				display[colnum] = StatsTable[i].hps
			end
			
			tt:AddLine(unpack(display,1,colcount))			
		end		
	end
	
	if not Broker_RecStatsConfig.hidehinttip then
		tt:AddLine(" ")
		templine = tt:AddLine("")
		tt:SetCell(templine, 1, "|cffeda55fLeft Click|r |cff19ff19on plugin to toggle Recount window on/off.", nil, "LEFT", colcount)
		templine = tt:AddLine("")
		tt:SetCell(templine, 1, "|cffeda55fAlt+Left Click|r |cff19ff19on plugin to reset Recount data.", nil, "LEFT", colcount)
		templine = tt:AddLine("")
		tt:SetCell(templine, 1, "|cffeda55fRight Click|r |cff19ff19on plugin to open the Configuration menu.", nil, "LEFT", colcount)
		templine = tt:AddLine("")
		tt:SetCell(templine, 1, "|cffeda55fMiddle Click|r |cff19ff19on plugin to reset Recount window position.", nil, "LEFT", colcount)
	end
	
	tt:UpdateScrolling(Broker_RecStatsConfig.slidermaxheight)	
end

function BRRecStats:UpdateFrequencyPopup()
StaticPopupDialogs["Broker_RecountStats_UpdateFrequency"] = {
	text = _G["NORMAL_FONT_COLOR_CODE"].."Broker Recount Statistics".."|r".."\n\n".."Enter a value (in seconds) that will define how frequently text will be updated.".."\n".."Allowed value range is (0.2 - 5).",
	button1 = _G["ACCEPT"],
	button2 = _G["CANCEL"],
	hasEditBox = 1,
	maxLetters = 3,
	OnAccept = function(self)
		local rawvalue = self.editBox:GetText()
		local freq = tonumber(rawvalue) or 0
		if freq < 0.2 or freq > 5 then return end
		Broker_RecStatsConfig.update_time = freq
	end,
	OnShow = function(self)
		self.editBox:SetFocus()
	end,
	OnHide = function(self)
		if ChatFrameEditBox:IsShown() then
			ChatFrameEditBox:SetFocus()
		end
		self.editBox:SetText("")
	end,
	EditBoxOnEnterPressed = function(self)
		local parent = self:GetParent()
		local rawvalue = parent.editBox:GetText()
		local freq = tonumber(rawvalue) or 0
		if freq < 0.2 or freq > 5 then parent:Hide() return end
		Broker_RecStatsConfig.update_time = freq
		parent:Hide()
	end,
	EditBoxOnEscapePressed = function(self)
		self:GetParent():Hide()
	end,
	timeout = 0,
	exclusive = 1,
	whileDead = 1,
	hideOnEscape = 1
}
StaticPopup_Show("Broker_RecountStats_UpdateFrequency")
end

function BRRecStats:UpdateSliderMaxHeight()
StaticPopupDialogs["Broker_RecountStats_UpdateSliderMaxHeight"] = {
	text = _G["NORMAL_FONT_COLOR_CODE"].."Broker Recount Statistics".."|r".."\n\n".."Enter the max height of the tooltip after which point, it will become scrollable.".."\n".."Allowed value range is (100 - 2000).",
	button1 = _G["ACCEPT"],
	button2 = _G["CANCEL"],
	hasEditBox = 1,
	maxLetters = 4,
	OnAccept = function(self)
		local rawvalue = self.editBox:GetText()
		local ttheight = tonumber(rawvalue) or 0
		if ttheight < 100 or ttheight > 2000 then return end
		Broker_RecStatsConfig.slidermaxheight = ttheight
	end,
	OnShow = function(self)
		self.editBox:SetFocus()
	end,
	OnHide = function(self)
		if ChatFrameEditBox:IsShown() then
			ChatFrameEditBox:SetFocus()
		end
		self.editBox:SetText("")
	end,
	EditBoxOnEnterPressed = function(self)
		local parent = self:GetParent()
		local rawvalue = parent.editBox:GetText()
		local ttheight = tonumber(rawvalue) or 0
		if ttheight < 100 or ttheight > 2000 then parent:Hide() return end
		Broker_RecStatsConfig.slidermaxheight = ttheight
		parent:Hide()
	end,
	EditBoxOnEscapePressed = function(self)
		self:GetParent():Hide()
	end,
	timeout = 0,
	exclusive = 1,
	whileDead = 1,
	hideOnEscape = 1
}
StaticPopup_Show("Broker_RecountStats_UpdateSliderMaxHeight")
end